// Vereinfachung: die Kennnummern der Unterfenster als Prprozessorkonstanten
// Moderner wre allerdings etwas wie:   const int idMyButtonA = 100;

#define IDB_A        100
#define IDB_SALT     101
#define IDB_SUGAR    102
#define IDO_GROUP    103
#define IDO_A        201
#define IDO_B        202
#define IDO_Z        203
#define IDB_SHOW     300
#define IDE_LARGE    301
#define IDE_OUT      302
#define IDB_SHOWTEXT 303
#define IDE_NUMBER   304
#define IDB_SPIN     305
#define IDS_A        306
#define IDS_B        307
#define IDS_BAR      308
#define IDC_COMBO    309
#define IDL_LIST     310
#define IDB_SHOWLIST 311
#define IDC_DATE     312
#define IDC_MONTH    313
#define IDB_SHOWDATE 314
#define IDB_CLOSE    400

#include "DemoMainFrame.h"

BEGIN_MESSAGE_MAP(DemoMainFrame, CFrameWnd)
	// Windows Messages:
	ON_WM_PAINT()
	ON_WM_HSCROLL() // Hier landen alle horizontalen Schieber zentral.

	// Notification Messages:
	ON_BN_CLICKED (IDB_SALT, OnButtonSalt)
	ON_BN_CLICKED (IDB_SHOW, OnButtonShow)
	ON_BN_CLICKED (IDB_SHOWTEXT, OnButtonShowText)
	ON_BN_CLICKED (IDB_SHOWLIST, OnButtonShowList)
	ON_BN_CLICKED (IDB_SHOWDATE, OnButtonShowDate)
	ON_BN_CLICKED (IDB_CLOSE, OnButtonClose)
END_MESSAGE_MAP()

DemoMainFrame::DemoMainFrame()
{
	Create(NULL, "Test", WS_OVERLAPPEDWINDOW,
		   CRect(CPoint(100, 100), CSize(550, 460)));

	stdFont.CreateStockObject(ANSI_VAR_FONT);
	// sonst siehts aus wie Windows 3.1

	int y = 10; // Hier zhlen wir y-Position mit, mangels Layout-Manager

	// Static-Control entspricht etwa JLabel bei Swing
	myStaticA.Create("CStatic mit extrem viel Text, damit er umbricht",
					 WS_CHILD | WS_VISIBLE | SS_CENTER,
					 CRect(CPoint(40, y), CSize(100, 40)), this);
	myStaticA.SetFont(&stdFont, FALSE);
	y += 40+10;
	// SS_CENTER = Text zentrieren
	// Braucht keine ID, weil keine Benutzerinteraktion.

	myStaticB.Create("CStatic ohne Umbruch mit arg viel Text",
					 WS_CHILD | WS_VISIBLE | SS_LEFTNOWORDWRAP,
					 CRect(CPoint(40, y), CSize(100, 40)), this);
	myStaticB.SetFont(&stdFont, FALSE);
	y += 40+10;

	// BS_PUSHBUTTON: Standardknopf
	// WS_TABSTOP: Knnen mit Tabulator dahinmarschieren
	myButtonA.Create("Knopf", WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_PUSHBUTTON,
					CRect(CPoint(40, y), CSize(100, 20)), this, IDB_A);
	myButtonA.SetFont(&stdFont, FALSE);
	myButtonA.EnableWindow(FALSE); // ausgrauen
	y += 20+10;

	// BS_3STATE: Checkbox ist Fall von CButton
	// BS_CHECKBOX: kann nur an/aus, nicht unbestimmt
	// Tastaturbedienung: Leertaste!
	myButtonSalt.Create("Salz", WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_3STATE,
					CRect(CPoint(40, y), CSize(100, 20)), this, IDB_SALT);
	myButtonSalt.SetFont(&stdFont, FALSE);
	y += 20+10;	

	// BS_AUTOCHECKBOX schaltet von selbst auf Mausklick um,
	// braucht also keinen Message-Handler fr ON_BN_CLICKED.
	myButtonSugar.Create("Zucker", WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_AUTOCHECKBOX,
					CRect(CPoint(40, y), CSize(100, 20)), this, IDB_SUGAR);
	myButtonSugar.SetFont(&stdFont, FALSE);
	y += 20+10;

	// Optionsknpfe (Radiobuttons) sind ebenfalls CButtons.
	// Zur _geometrischen_ Gruppierung dient ein weiterer CButton.
	// Die Kennzahlen (IDs) der Optionsknpfe selbst mssen lckenlos
	// aufeinanderfolgen (= _logische_ Gruppe).

	int y0 = y; // obere Kante merken
	y+= 20+5;

	myOptionA.Create("Ameisen", WS_CHILD | WS_VISIBLE | WS_TABSTOP
					 | BS_AUTORADIOBUTTON | WS_GROUP,
					 CRect(CPoint(50, y), CSize(80, 20)), this, IDO_A);
	// WS_GROUP im ersten RadioButton sorgt fr die Logik.
	myOptionA.SetFont(&stdFont, FALSE);
	y+= 20+5;

	myOptionB.Create("Bren", WS_CHILD | WS_VISIBLE | WS_TABSTOP
					 | BS_AUTORADIOBUTTON,
					 CRect(CPoint(50, y), CSize(80, 20)), this, IDO_B);
	myOptionB.SetFont(&stdFont, FALSE);
	y+= 20+5;

	myOptionZ.Create("Zebras", WS_CHILD | WS_VISIBLE | WS_TABSTOP
					 | BS_AUTORADIOBUTTON,
					 CRect(CPoint(50, y), CSize(80, 20)), this, IDO_Z);
	myOptionZ.SetFont(&stdFont, FALSE);
	y+= 20+5;

	myOptionGroup.Create("Optionen",
						 WS_CHILD | WS_VISIBLE | BS_GROUPBOX,
						 CRect(40, y0, 140, y), this, IDO_GROUP);
	// BS_GROUPBOX sorgt fr Rahmen und berschrift
	myOptionGroup.SetFont(&stdFont, FALSE);
	CheckRadioButton(IDO_A, IDO_Z, IDO_B); // Optionsknopf IDO_B anschalten
	y += 10+10;

	myStaticOut1.Create("---",
					 WS_CHILD | WS_VISIBLE | SS_SUNKEN,
					 CRect(CPoint(40, y), CSize(100, 40)), this);
	// versenkt mit SS_SUNKEN, damit es mehr nach Ausgabe aussieht
	myStaticOut1.SetFont(&stdFont, FALSE);
	y += 40+10;

	myButtonShow.Create("Zeige Auswahl", WS_CHILD | WS_VISIBLE | WS_TABSTOP |
					    BS_PUSHBUTTON,
					    CRect(CPoint(40, y), CSize(100, 20)), this, IDB_SHOW);
	myButtonShow.SetFont(&stdFont, FALSE);
	y += 20+10;

	// zweite Spalte ****************

	y = 10;
	
	myEditLarge.Create(WS_CHILD | WS_VISIBLE | WS_BORDER |
					   ES_MULTILINE | ES_WANTRETURN |
					   WS_HSCROLL | ES_AUTOHSCROLL | WS_VSCROLL | ES_AUTOVSCROLL,
					   CRect(CPoint(160, y), CSize(100, 150)), this, IDE_LARGE);
	// WS_BORDER, damit durch Rahmen als Eingabefeld erkannbar
	// ES_MULTILINE, damit so viele Zeilen, wie Platz
	// ES_WANTRETURN, um Return-Tastendrcke zu erhalten
	// WS_HSCROLL und WS_VSCROLL zeigen Scrollbalken.
	// ES_AUTOHSCROLL schaltet auch Umbruch aus.
	// unter Windows 95 max. 64 KByte Text
	myEditLarge.SetFont(&stdFont, FALSE);
	myEditLarge.SetWindowText("Auch Copy und Paste!");
	y += 150+10;

	myEditOutput.Create(WS_CHILD | WS_VISIBLE | WS_BORDER |
						ES_MULTILINE | ES_AUTOHSCROLL | ES_AUTOVSCROLL |
						ES_READONLY,
						CRect(CPoint(160, y), CSize(100, 60)), this, IDE_OUT);
	// ES_READONLY, um Eingabe zu verhindern
	// Flche wird grau
	myEditOutput.SetFont(&stdFont, FALSE);
	myEditOutput.SetWindowText("Auch HIER Copy!");
	y += 60+10;

	myButtonShowText.Create("Zeige Text",
							WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_PUSHBUTTON,
							CRect(CPoint(160, y), CSize(100, 20)), this, IDB_SHOWTEXT);
	myButtonShowText.SetFont(&stdFont, FALSE);
	y += 20+10;

	myEditNumber.Create(WS_CHILD | WS_VISIBLE | WS_BORDER,
						CRect(CPoint(160, y), CSize(100, 20)), this, IDE_NUMBER);
	myEditNumber.SetFont(&stdFont, FALSE);

	mySpin.Create(WS_CHILD | WS_VISIBLE |
				  UDS_SETBUDDYINT | UDS_ALIGNRIGHT,
				  CRect(1,2,3,4), this, IDB_SPIN);
	// UDS_SETBUDDYINT: CEdit als "Buddy" ankoppeln und ganzzahlig verstellen.
	// Spin Button steht wegen UDS_ALIGNRIGHT rechts im (!) Fenster des Buddy
	// UDS_HORZ fr horizontalen Spin.
	mySpin.SetBuddy(&myEditNumber);
	mySpin.SetRange(1, 42);
	mySpin.SetPos(13);
	y += 20+10;

	mySliderOut.Create("---", WS_CHILD | WS_VISIBLE | SS_SUNKEN,
					   CRect(CPoint(160, y), CSize(100, 20)), this);
	mySliderOut.SetFont(&stdFont, FALSE);
	y += 20+10;

	mySliderA.Create(WS_CHILD | WS_VISIBLE | WS_TABSTOP | TBS_HORZ,
					CRect(CPoint(160, y), CSize(100, 30)), this, IDS_A);
	// "TBS" historisch: Trackbar Style, nicht Slider Style
	mySliderA.SetRange(1, 42);
	mySliderA.SetPos(13);	
	mySliderA.SetLineSize(1); // Cursortaste
	mySliderA.SetPageSize(5); // Bildlauftaste; Klick neben Schieber
	y += 30+7;

	mySliderB.Create(WS_CHILD | WS_VISIBLE | WS_TABSTOP | TBS_HORZ |
					TBS_AUTOTICKS | TBS_TOP,
					CRect(CPoint(160, y), CSize(100, 30)), this, IDS_B);
	// TBS_AUTOTICKS: Teilstriche, und zwar oben (TBS_TOP)
	mySliderB.SetRange(1, 42);
	mySliderB.SetPos(13);
	mySliderB.SetTicFreq(7); // Abstand der Teilstriche
	mySliderB.SetLineSize(2);
	mySliderB.SetPageSize(7);
	y += 30+7;

	myScrollBar.Create(WS_CHILD | WS_VISIBLE | WS_TABSTOP | SBS_HORZ,
					CRect(CPoint(160, y), CSize(100, 16)), this, IDS_BAR);
	// wohlgemerkt SBS_HORZ
	myScrollBar.SetScrollRange(1, 42, FALSE); // FALSE: nicht neuzeichnen
	myScrollBar.SetScrollPos(13, FALSE);

	// dritte Spalte  ****************

	y = 10;

	myCombo.Create(WS_CHILD | WS_VISIBLE | WS_TABSTOP | WS_VSCROLL |
				   WS_BORDER | CBS_DROPDOWNLIST | CBS_SORT,
				   CRect(CPoint(280, y), CSize(100, 70)), this, IDC_COMBO);
	// WS_VSCROLL: Scrollbar an Liste
	// CBS_DROPDOWN: auf Mausklick Liste aufklappen
	// CBS_DROPDOWNLIST: nur Werte aus der Liste mglich
	// CBS_SIMPLE: Liste immer zu sehen
	// CBS_SORT: alphabetisch sortieren
	// Die Hhe von CRect bestimmt die sichtbare Lnge der Liste.
	myCombo.SetFont(&stdFont, FALSE);
	y += 40+10;

	int i;
	i = myCombo.AddString("Caesar");
	myCombo.SetItemData(i, 42);
	// Jedem String kann ein 32-Bit-Wert
	// oder ein Pointer (SetItemDataPtr) mitgegeben werden.
	// Das macht die Identifikation nachher einfacher.
	i = myCombo.AddString("Alice");
	myCombo.SetItemData(i, 43);
	i = myCombo.AddString("Bert");
	myCombo.SetItemData(i, 44);
	i = myCombo.AddString("nne");
	myCombo.SetItemData(i, 45);
	myCombo.SetCurSel(0);

	myList.Create(WS_CHILD | WS_VISIBLE | WS_TABSTOP | WS_VSCROLL |
				  WS_BORDER | LBS_SORT | LBS_MULTIPLESEL,
				  CRect(CPoint(280, y), CSize(100, 60)), this, IDL_LIST);
	// LBS_SORT: alphabetisch sortieren
	// LBS_MULTIPLESEL: Mehrfachauswahl erlaubt
	myList.SetFont(&stdFont, FALSE);
	y += 60+10;

	i = myList.AddString("Heinz");
	myList.SetItemData(i, 46); // Daten anhngen, wie bei Combo-Box
	i = myList.AddString("Berta");
	myList.SetItemData(i, 53);
	i = myList.AddString("Egon");
	myList.SetItemData(i, 13);
	i = myList.AddString("Herta");
	myList.SetItemData(i, 76);
	i = myList.AddString("Paul");
	myList.SetItemData(i, 64);

	myStaticOut2.Create("---",
						WS_CHILD | WS_VISIBLE | WS_TABSTOP | SS_SUNKEN,
						CRect(CPoint(280, y), CSize(100, 40)), this);
	myStaticOut2.SetFont(&stdFont, FALSE);
	y += 40+10;

	myButtonShowList.Create("Zeige Auswahl",
							WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_PUSHBUTTON,
							CRect(CPoint(280, y), CSize(100, 20)), this, IDB_SHOWLIST);
	myButtonShowList.SetFont(&stdFont, FALSE);
	y += 20+10;

	myDate.Create(WS_CHILD | WS_VISIBLE | WS_TABSTOP,
				  CRect(CPoint(280, y), CSize(100, 20)), this, IDC_DATE);
	y += 20+10;

	// Monat und Jahr kann man auch anklicken!
	myMonth.Create(WS_CHILD | WS_VISIBLE | WS_TABSTOP,
				   CRect(CPoint(280, y), CSize(220, 120)), this, IDC_MONTH);
	// Hier gibt es endlose Mglichkeiten, siehe www.msdn.microsoft.com
	y += 120+10;

	myStaticOut3.Create("---",
					 WS_CHILD | WS_VISIBLE | WS_TABSTOP | SS_SUNKEN,
					 CRect(CPoint(280, y), CSize(100, 20)), this);
	myStaticOut3.SetFont(&stdFont, FALSE);
	y += 20+10;

	myButtonShowDate.Create("Zeige Tage",
							WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_PUSHBUTTON,
							CRect(CPoint(280, y), CSize(100, 20)), this, IDB_SHOWDATE);
	myButtonShowDate.SetFont(&stdFont, FALSE);

	// vierte Spalte  ****************

	y = 10;

	// BS_DEFPUSHBUTTON: dicker Rand
	myButtonClose.Create("Schlieen", WS_CHILD | WS_VISIBLE |
						 WS_TABSTOP | BS_DEFPUSHBUTTON,
						 CRect(CPoint(400, y), CSize(100, 20)), this, IDB_CLOSE);
	myButtonClose.SetFont(&stdFont, FALSE);
	myButtonClose.SetFocus(); // Tastendrcke (zu Beginn) hierhin
	y += 20+10;
}

// PreTranslateMessage erlaubt das Durchlaufen mit Tabulatortaste.
// Bei CDialog-Fenstern ist das Folgende schon eingebaut.
BOOL DemoMainFrame::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message >= WM_KEYFIRST && pMsg->message <= WM_KEYLAST)
	// War es eine Taste?
	{
		// Falls ja, die globale (deshalb ::) Funktion
		// IsDialogMessage aufrufen, welche entsprechend reagiert
		// und TRUE zurckliefert, wenn sie ttig geworden ist.
		return ::IsDialogMessage(m_hWnd, pMsg);
    }
	
	return FALSE; // Wir haben es nicht selbst behandelt.
}

void DemoMainFrame::OnPaint()
{
	CPaintDC dc(this);

	// Male den Hintergrund grau.
	// Ist nur ntig, weil wir hier keine Dialogbox haben,
	// sondern ein "groes" Fenster. Der Rahmen ist eigentlich falsch.
	CRect r;
	GetClientRect(r);
	++r.bottom; // dc.Rectangle malt sonst einen Pixel zu wenig
	++r.right;
	dc.SelectStockObject(LTGRAY_BRUSH); // hellgraue Fllung
	dc.SelectStockObject(NULL_PEN); // kein Umriss
	dc.Rectangle(r);
}

void DemoMainFrame::OnButtonSalt()
{
	switch(myButtonSalt.GetCheck())
	{
	case BST_UNCHECKED:
		myButtonSalt.SetCheck(BST_CHECKED);
		break;
	case BST_CHECKED:
		myButtonSalt.SetCheck(BST_INDETERMINATE); // Unsinn, zur Demo
		break;
	case BST_INDETERMINATE:
		myButtonSalt.SetCheck(BST_UNCHECKED); // Unsinn, zur Demo
		break;
	default: // Oops?
		;
	}
}

void DemoMainFrame::OnHScroll(UINT nSBCode, INT nPos, CWnd* pCtrl)
{
	// Hier kommen zentral die Meldungen ber alle
	// horizontalen Slider und Scrollbars an.

	char c = 0;
	int x;

	// Welcher Slider war es?
	if(pCtrl == (CWnd*)&mySliderA) // Aufwrts-Casten ist unproblematisch.
	{
		c = 'A';
		x = mySliderA.GetPos();
	}

	if(pCtrl == (CWnd*)&mySliderB)
	{
		c = 'B';
		x = mySliderB.GetPos();
	}

	if(pCtrl == (CWnd*)&myScrollBar)
	{
		c = 'X';
		x = myScrollBar.GetScrollPos();

		// Beim Scroll Bar muss man alles zu Fu machen ...
		int min, max;
		myScrollBar.GetScrollRange(&min, &max);

		switch(nSBCode)
		{
		case SB_LINEUP:   x -=  1; break;
		case SB_LINEDOWN: x +=  1; break;
		case SB_PAGEUP:   x += 10; break;
		case SB_PAGEDOWN: x -= 10; break;
		case SB_TOP:      x = min; break; // Taste "Pos1"
		case SB_BOTTOM:   x = max; break; // Taste "Ende"
		case SB_THUMBPOSITION: x = nPos; break;
		default: return; // Oops?
		}

		if(x < min) // Wenn man nicht am Schieber zieht,
		{           // kann der Bereich verlassen werden.
			x = min;
		}
		else if(x > max)
		{
			x = max;
		}

		myScrollBar.SetScrollPos(x);
	}

	if (c != 0)
	{
		CString s;
		s.Format("Slider %c auf %d.", c, x);
		mySliderOut.SetWindowText(s);
	}
}

void DemoMainFrame::OnButtonShow()
{
	CString s = "Auswahl: ";
	s += (myButtonSalt.GetCheck()  == BST_CHECKED) ? "Salz "   : " ";
	s += (myButtonSugar.GetCheck() == BST_CHECKED) ? "Zucker " : " ";

	int opt = GetCheckedRadioButton(IDO_A, IDO_Z);
	// Argumente: Kennzahlen des ersten und des letzten Optionsknopfs.
	// Vorsicht: Ist eine Methode des Fensters, nicht der Optionsgruppe!

	switch(opt)
	{
	case IDO_A:
		s += "Ameisen";
		break;
	case IDO_B:
		s += "Bren";
		break;
	case IDO_Z:
		s += "Zebras";
		break;
	default: // Oops?
		;
	}

	myStaticOut1.SetWindowText(s);
}

void DemoMainFrame::OnButtonShowText()
{
	CString s;
	myEditLarge.GetWindowText(s);
	myEditOutput.SetWindowText(s);
}

void DemoMainFrame::OnButtonShowList()
{
	int index1 = myCombo.GetCurSel();
	CString string1;
	myCombo.GetLBText(index1, string1); // in string1 geschrieben
	int data1 = myCombo.GetItemData(index1); // hier nicht benutzt

	// mit Liste schwieriger, weil Mehrfachauswahl erlaubt
	int index2[10];
	CString string2[10];
	int data2[10];
	myList.GetSelItems(10, index2); // liefere maximal 10 selektierte
	int number = myList.GetSelCount();
	if(number > 10)
	{
		number = 10;
	}

	int j;
	for(j=0; j<number; ++j)
	{
		myList.GetText(index2[j], string2[j]);
		data2[j] = myList.GetItemData(index2[j]); // hier nicht benutzt
	}

	CString s = string1;
	for(j=0; j<number; ++j)
	{
		s += " " + string2[j];
	}

	myStaticOut2.SetWindowText(s);
}

void DemoMainFrame::OnButtonShowDate()
{
	CString s;

	CTime t1;
	myDate.GetTime(t1);

	CString day1[] = {"Fehler", "So", "Mo", "Di", "Mi", "Do", "Fr", "Sa"};
	// Sonntag ist der erste Tag!

	s = day1[t1.GetDayOfWeek()] + ", ";

	// CTime t2;
	// myMonth.GetCurSel(t2); // Ist fehlerhaft!
	// Workaround nach Kuglinski:
	
	SYSTEMTIME t3;
	::SendMessage(myMonth.GetSafeHwnd(), MCM_GETCURSEL, 0, (LPARAM)&t3);
	// t2 = CTime(t3); // Auch falsch!

	CString day2[] = {"So", "Mo", "Di", "Mi", "Do", "Fr", "Sa"};
	s += day2[t3.wDayOfWeek];

	myStaticOut3.SetWindowText(s);
}

void DemoMainFrame::OnButtonClose()
{
	DestroyWindow(); // Minimallsung
}